#    Quick Access Menu server v.0.90 for Python S60 2nd Edition.
#    Copyright (C) 2008  Alexei Muzarov (AZEX)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY
#WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#    if you have any question or you want to contact me,
#    e-mail: azexmail@gmail.com

__author__="Alexei Muzarov (azexmail@gmail.com)"

__date__='14 Nov 2008 - 01 Dec 2008'

__copyright__="Copyright (C) 2008 Alexei Muzarov (AZEX)"

__license__="GPL"

__version__="0.90"

__credits__="From Quick Access Menu project"

__doc__=u'Quick Access Menu server v.0.90 for Python S60 2nd Edition.'

import keycapture
import globalui
import e32
import sys
import laa
from sys import setdefaultencoding
from _PyKeyLock import LockStatus

setdefaultencoding('utf-8')
ru=unicode


lock=e32.Ao_lock()

class QAM:
    def __init__(s):
        s.swch = 0
        s.codelist = [49, 50, 51, 52, 53, 54, 55, 56, 57, 42, 48, 35]
        cf=open(u'c:\\system\\data\\quickaccessmenu.cnf','rb')
        cont=cf.read().decode('zlib')
        cont=eval(cont)
        cf.close()
        if not __version__ == cont['version']: raise SystemExit
        s.applist = cont[u'applist']
        s.uidlist = cont[u'uidlist']
        s.menutitle = ru(cont[u'title'])
        s.quick = cont[u'quick']
        s.hkeys = cont[u'keys']
        s.sens = cont[u'sens']
        for stp in range(len(s.applist)):
            s.applist[stp] = ru(ru(stp+1)+u' '+s.applist[stp])
        s.key1 = keycapture.KeyCapturer(s.keyswitcher)
        s.key1.keys = [s.hkeys[0]]
        s.key1.forwarding = 1
        s.key2 = keycapture.KeyCapturer(s.menu)
        s.key2.keys = [s.hkeys[1]]
        if s.quick: s.key2.keys += s.codelist
        s.key2.forwarding = 0
        s.key1.start()
    #само меню
    def menu(s, code):
        if code == s.hkeys[1]:
            s.swch = 1
            s.key2.stop()
            index = globalui.global_popup_menu(s.applist, s.menutitle)
            if index != (-1):
                laa.execute(s.uidlist[index])
            s.swch = 0
        else:
            index = s.codelist.index(code)
            if index < len(s.applist):
                laa.execute(s.uidlist[index])
        s.key1.start()
    #ожидание нажатия второй клавиши
    def keyswitcher(s, code):
        if LockStatus() == 0:
            s.key1.stop()
            s.key2.start()
            e32.ao_sleep(s.sens)
            if not s.swch:
                s.key2.stop()
                s.key1.start()

e32.ao_sleep(0.1, QAM)
lock.wait()