#    Quick Access Menu launcher (QAM) v.0.90 for Python S60 2nd Edition.
#    Copyright (C) 2008  Alexei Muzarov (AZEX)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY
#WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#    if you have any question or you want to contact me,
#    e-mail: azexmail@gmail.com

__author__="Alexei Muzarov (azexmail@gmail.com)"

__date__='14 Nov 2008 - 01 Dec 2008'

__copyright__="Copyright (C) 2008 Alexei Muzarov (AZEX)"

__license__="GPL"

__version__="0.90"

__credits__="From Quick Access Menu project"

__doc__=u'Quick Access Menu launcher (QAM) v.0.90 for Python S60 2nd Edition.'

import keycapture
import appuifw as aw
import applist
import uitricks
import appswitch
import e32
import sys
import os.path
from graphics import Image

sys.setdefaultencoding('utf-8')
ru=unicode

lock=e32.Ao_lock()


class QAM:
    def __init__(s):
        #путь к файлу настроек
        s.conf=u'c:\\system\\data\\quickaccessmenu.cnf'
        if not os.path.isfile(s.conf):
            #проверка существования файла настроек
            s.reset()
        #списки сутоковых символов на цифровой клавиатуре
        s.key0 = [u' ', u'0']
        s.key1 = [u'1', u'.', u"'", u'?', u'!', u'"', u'-', u'(', u')', u'@', u'/', u':', u'_', u';', u'+', u'&', u'%', u'*', u'=', u'<', u'>', u'\xa3', u'\u20ac', u'$', u'\xa5', u'\xa4', u'[', u']', u'{', u'}', u'\\', u'~', u'^', u'\xa1', u'\xbf', u'\xa7', u'#', u'|']
        s.key2 = [u'a', u'b', u'c', u'\u0430', u'\u0431', u'\u0432', u'\u0433', u'2']
        s.key3 = [u'd', u'e', u'f', u'\u0434', u'\u0435', u'\u0451', u'\u0436', u'\u0437', u'3']
        s.key4 = [u'g', u'h', u'i', u'\u0438', u'\u0439', u'\u043a', u'\u043b', u'4']
        s.key5 = [u'j', u'k', u'l', u'\u043c', u'\u043d', u'\u043e', u'\u043f', u'5']
        s.key6 = [u'm', u'n', u'o', u'\u0440', u'\u0441', u'\u0442', u'\u0443', u'6']
        s.key7 = [u'p', u'q', u'r', u's', u'\u0444', u'\u0445', u'\u0446', u'\u0447', u'7']
        s.key8 = [u't', u'u', u'v', u'\u0448', u'\u0449', u'\u044a', u'\u044b', u'8']
        s.key9 = [u'w', u'x', u'y', u'z', u'\u044c', u'\u044d', u'\u044e', u'\u044f', u'9']
        #шаг поиска
        s.search = 0
        #положение курсора в списке
        s.searchpos = []
        #получение списков всех установленных программ и их uid'ов
        apnlist = []
        apuidlist = []
        alist = applist.applist()
        for stp in alist:
            apnlist.append(ru(stp[1]))
            apuidlist.append(stp[0])
            e32.ao_yield()
        s.apnlist = [apnlist]
        s.apuidlist = [apuidlist]
        #прочтение настроек
        s.getconf()
        #загрузка графических образов
        s.img = Image.new((176, 144))
        s.img1 = Image.open(sys.path[0] + u'\\keypad.png')
        s.img2 = Image.open(sys.path[0] + u'\\arrow_i.png')
        s.img2m = Image.new((10, 15), mode = '1')
        s.img2m.load(sys.path[0] + u'\\arrow_m.png')
        s.img3 = Image.new((104, 111), mode = '1')
        s.img3.clear(0x0)
        s.img3m = Image.new((104, 111), mode = 'L')
        s.img3m.load(sys.path[0] + u'\\keypad_m.png')
        s.step = 0
        s.scode = [164, 165, 196, 167, 14, 15, 16, 17, 1, 18, 49, 50, 51, 52, 53, 54, 55, 56, 57, 42, 48, 127]
        s.codes = [63554, 63555, 63586, 63557, 63495, 63496, 63497, 63498, 8, 63499, 49, 50, 51, 52, 53, 54, 55, 56, 57, 42, 48, 35]
        s.coord = [(64, 36), (106, 36), (62,46 ), (88, 41),
(78, 41), (95, 43),
(89, 32), (86, 48),
(123, 34), (125, 48),
(59, 61), (87, 62),
(114, 60), (58, 75),
(90, 77), (111, 75),
(57, 90), (88, 91),
(114, 90), (57, 105),
(87, 109), (114, 104)]
        s.hot = [u'LeftSoft', u'RightSoft', u'GreenKey', u'Center', u'Left', u'Right', u'Up', u'Down', u'C', u'Pen', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9', u'*', u'0', u'#']
        s.senslist = [0.05, 0.08, 0.13, 0.17, 0.2, 0.23, 0.26, 0.3, 0.34, 0.38]
        s.sensid = s.senslist.index(s.sens)
        s.canv = aw.Canvas(event_callback = s.keycall, redraw_callback = s.redraw)
        aw.app.body = s.canv
        s.Img = Image.open(sys.path[0]+u'\\azex.png')
        #иконки в настройках
        i = ru(sys.path[0]+'\\settings.mbm')
        s.icon1=aw.Icon(i, 0, 1)
        s.icon2=aw.Icon(i, 2, 3)
        s.icon3=aw.Icon(i, 4, 5)
        s.icon4=aw.Icon(i, 6, 7)
        s.icon5=aw.Icon(i, 8, 9)
        if s.quick: quick=ru(s.lgf[15])
        else: quick=ru(s.lgf[16])
        s.lb4=aw.Listbox([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], s.settings)
        s.keymove=keycapture.KeyCapturer(s.moveit)
        s.keymove.keys=[63497, 63498]
        s.keymove.forwarding=0
        aw.app.body = s.lb2
        s.lbbody=aw.app.body
        aw.app.title = ru(s.lgf[0])
        s.lbtitle = aw.app.title
        s.tab=0
        s.Listbox()
        s.lb2.bind(8, s.delapp)
        s.lb2.bind(42, s.renameapp)
        s.lb1.bind(48, lambda: s.searching(s.key0))
        s.lb1.bind(49, lambda: s.searching(s.key1))
        s.lb1.bind(50, lambda: s.searching(s.key2))
        s.lb1.bind(51, lambda: s.searching(s.key3))
        s.lb1.bind(52, lambda: s.searching(s.key4))
        s.lb1.bind(53, lambda: s.searching(s.key5))
        s.lb1.bind(54, lambda: s.searching(s.key6))
        s.lb1.bind(55, lambda: s.searching(s.key7))
        s.lb1.bind(56, lambda: s.searching(s.key8))
        s.lb1.bind(57, lambda: s.searching(s.key9))
        s.lb1.bind(8, s.searchback)
        s.lb1.bind(63586, s.searchreset)
        s.lb1.bind(35, lambda: s.apnscroll(1))
        s.lb1.bind(42, lambda: s.apnscroll(-1))
    #раздел Listbox
    def Listbox(s):
        s.swch = 0
        uitricks.set_text(ru(s.lgf[7]),3009)
        uitricks.set_text(ru(s.lgf[22]),3000)
        s.keymove.stop()
        aw.app.focus = None
        aw.app.exit_key_handler = s.exit
        aw.app.menu=[(ru(s.lgf[8]), s.menulauncher), (ru(s.lgf[21]), s.about)]
        aw.app.set_tabs([u'1',
u'2',u'3'],
s.titles)
        aw.app.activate_tab(s.tab)
        aw.app.body = s.lbbody
        aw.app.title = s.lbtitle
    #добавление приложения в меню
    def addapp(s):
        if not s.apuidlist[-1][s.lb1.current()] in s.uids:
            s.aplist.append(s.apnlist[-1][s.lb1.current()])
            s.uids.append(s.apuidlist[-1][s.lb1.current()])
            s.make_keylist()
            s.lb2.set_list(s.keylist, s.lb2.current())
            s.writeconf()
    #удаление приложения из меню
    def delapp(s):
        if not s.aplist==[]:
            del s.aplist[s.lb2.current()]
            del s.uids[s.lb2.current()]
            s.writeconf()
            s.make_keylist()
            if s.keylist==[]:
                s.keylist=[u'...']
        s.lb2.set_list(s.keylist, s.lb2.current())
    #перемещение приложения по списку
    def displace(s):
        if not s.aplist == []:
            uitricks.set_text(ru(s.lgf[6]),3009)
            aw.app.menu=[(ru(s.lgf[6]), s.Listbox)]
            aw.app.exit_key_handler = s.Listbox
            s.mvind=s.lb2.current()
            s.len=len(s.keylist)
            s.mvapp=s.aplist[s.mvind]
            s.mvuid=s.uids[s.mvind]
            aw.app.title = ru(s.lgf[17])
            aw.app.set_tabs([],
s.titles)
            s.lb3=aw.Listbox(s.keylist, s.Listbox)
            s.lb3.bind(63495, lambda: s.moveto(-1))
            s.lb3.bind(63496, lambda: s.moveto(1))
            s.keymove.start()
            aw.app.focus=s.focus1
            aw.app.body=s.lb3
            s.lb3.set_list(s.keylist, s.mvind)
    def moveit(s,code):
        if code==63497: s.moveto(-1)
        elif code==63498: s.moveto(1)
    def focus1(s,com):
        if com: s.keymove.start()
        else: s.keymove.stop()
    #собственно перемещение
    def moveto(s, com):
        del s.aplist[s.mvind]
        del s.uids[s.mvind]
        s.mvind += com
        if s.mvind >= s.len: s.mvind = 0
        if s.mvind < 0: s.mvind = s.len-1
        s.aplist.insert(s.mvind, s.mvapp)
        s.uids.insert(s.mvind, s.mvuid)
        s.make_keylist()
        s.lb2.set_list(s.keylist, s.mvind)
        s.lb3.set_list(s.keylist, s.mvind)
        s.writeconf()
    #переименовка предложений в меню (по нажатию клавиши 0)
    def renameapp(s):
        if not s.aplist == []:
            s.mvind = s.lb2.current()
            appn = aw.query(ru(s.lgf[23]+':'), 'text', ru(s.aplist[s.lb2.current()]))
            if appn == None: return
            s.aplist[s.lb2.current()] = appn
            s.make_keylist()
            s.lb2.set_list(s.keylist, s.mvind)
            s.writeconf()
    #создание списка keylist, пронумеровка приложений
    def make_keylist(s):
        s.keylist=[]
        for stp in s.aplist:
            s.keylist.append(stp)
            e32.ao_yield()
        for stp in range(len(s.keylist)):
            s.keylist[stp] = unicode(stp+1)+u' '+s.keylist[stp]
            e32.ao_yield()
    #функция, занимающаяся поиском
    def searching(s, k):
        if len(s.apuidlist[-1]) > 1:
            tmpapp = []
            tmpuid = []
            symbl = k
            for stp in range(len(s.apnlist[-1])):
                if len(s.apnlist[-1][stp]) >= (s.search+1) and (s.apnlist[-1][stp].lower()[s.search] in symbl):
                    tmpapp.append(s.apnlist[-1][stp])
                    tmpuid.append(s.apuidlist[-1][stp])
            if not tmpapp == []:
                s.search += 1
                s.searchpos.append(s.lb1.current())
                s.apnlist.append(tmpapp)
                s.apuidlist.append(tmpuid)
                s.lb1.set_list(s.apnlist[-1])
    #поиск обратно
    def searchback(s):
        if s.search:
            s.search -= 1
            del s.apnlist[-1], s.apuidlist[-1]
            s.lb1.set_list(s.apnlist[-1],s.searchpos[-1])
            del s.searchpos[-1]
    #мгновенный возврат к полному списку приложений
    def searchreset(s):
        if s.search:
            s.search = 0
            s.searchpos = []
            del s.apnlist[1:], s.apuidlist[1:]
            s.lb1.set_list(s.apnlist[-1])
    #скролл по списку приложений
    def apnscroll(s, com):
        lb1cur = s.lb1.current()
        if com == 1:
            if lb1cur == len(s.apnlist[-1]) - 1:
                s.lb1.set_list(s.apnlist[-1], 0)
                return
            lb1cur += 5
            s.lb1.set_list(s.apnlist[-1], lb1cur)
        elif com == -1:
            if lb1cur == 0:
                s.lb1.set_list(s.apnlist[-1], (len(s.apnlist[-1]) - 1))
                return
            lb1cur -= 5
            if lb1cur < 0:
                lb1cur = 0
            s.lb1.set_list(s.apnlist[-1], lb1cur)
    #прочтение настроек
    def getconf(s):
        cf=open(s.conf,'rb')
        cont=cf.read().decode('zlib')
        s.cont=eval(cont)
        cf.close()
        if not __version__ == s.cont['version']:
            s.reset()
        s.aplist=s.cont[u'applist']
        s.uids = s.cont[u'uidlist']
        s.menutitle = s.cont[u'title']
        s.quick = s.cont[u'quick']
        s.lang = s.cont[u'lang']
        s.hkeys = s.cont[u'keys']
        s.sens = s.cont[u'sens']
        s.langread()
        s.lgf=s.LangBases[s.lang]
        if s.aplist==[]:
            s.keylist=[u'...']
        else:
            s.make_keylist()
        s.lb2 = aw.Listbox(s.keylist, s.displace)
        s.lb1 = aw.Listbox(s.apnlist[-1], s.addapp)
    #запись настроек
    def writeconf(s):
        s.cont[u'applist'] = s.aplist
        s.cont[u'uidlist'] = s.uids
        s.cont[u'title'] = s.menutitle
        s.cont[u'quick'] = s.quick
        s.cont[u'lang'] = s.lang
        s.cont[u'keys'] = s.hkeys
        s.cont[u'sens'] = s.sens
        cf=open(s.conf,'wb')
        cf.write(repr(s.cont).encode('zlib'))
        cf.close()
    #сброс на стандартные настройки
    def reset(s):
        s.cont = {u'version': '0.90', u'applist': [], u'uidlist': [], u'quick': 0, u'title': u'', u'lang': u'English', u'keys': [63499, 63586], u'sens': 0.3}
        cf = open(s.conf,'wb')
        cf.write(repr(s.cont).encode('zlib'))
        cf.close()
    #чтение языковой базы
    def langread(s):
        cf=open(ru(sys.path[0]+'\\multilang.dat'),'rb')
        cont=cf.read().decode('zlib')
        s.LangBases=eval(cont)
        cf.close()
    #callback tab'ов
    def titles(s,tab):
        if tab == 0:
            aw.app.body=s.lb2
            aw.app.title=ru(s.lgf[0])
        elif tab == 1:
            aw.app.body=s.lb1
            aw.app.title=ru(s.lgf[1])
        elif tab == 2:
            aw.app.body=s.lb4
            aw.app.title=ru(s.lgf[2])
        s.lbbody=aw.app.body
        s.lbtitle=aw.app.title
        s.tab=tab
    #настройки: заголовок, язык, быстрые ссылки, клавиши вызова меню
    def settings(s):
        current=s.lb4.current()
        if current==0:
            if not s.menutitle==u'':
                index=aw.popup_menu([ru(s.lgf[18]),ru(s.lgf[19])],ru(s.lgf[3]+':'))
                if index==None:
                    return
                elif index==0:
                    ttl=aw.query(ru(s.lgf[3]+':'), 'text', s.menutitle)
                    if not ttl: return
                    s.menutitle=ttl
                elif index==1:
                    s.menutitle=u''
                s.writeconf()
                if s.quick:
                    quick=ru(s.lgf[15])
                else:
                    quick=ru(s.lgf[16])
                s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], current)
            else:
                ttl=aw.query(ru(s.lgf[3]+':'), 'text')
                if not ttl:
                    return
                s.menutitle=ttl
                s.writeconf()
                if s.quick:
                    quick=ru(s.lgf[15])
                else:
                    quick=ru(s.lgf[16])
                s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], current)
        elif current==1:
            lglist=map(ru, s.LangBases.keys())
            lglist.sort()
            index=aw.popup_menu(lglist,ru(s.lgf[4]+':'))
            if index==None or lglist[index]==s.lang:
                return
            s.lang=lglist[index]
            s.lgf=s.LangBases[s.lang]
            aw.app.title=ru(s.lgf[2])
            aw.app.menu=[(ru(s.lgf[8]), s.menulauncher), (ru(s.lgf[21]), s.about)]
            uitricks.set_text(ru(s.lgf[7]),3009)
            uitricks.set_text(ru(s.lgf[22]),3000)
            if s.quick:
                quick=ru(s.lgf[15])
            else:
                quick=ru(s.lgf[16])
            s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], current)
            s.writeconf()
        elif current==2:
            if s.quick:
                s.quick=0
                quick=ru(s.lgf[16])
            else:
                s.quick=1
                quick=ru(s.lgf[15])
            s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], current)
            s.writeconf()
        elif current==3:
            s.setkeys()
        elif current==4:
            s.setsens()
    #проверка запуска меню
    def findqam(s):
        proc=appswitch.process_list()
        killpro = None
        for stp in proc:
            if stp[0:15].lower() == u'quickaccessmenu':
                killpro = stp
                break
        return killpro
    #ланчер меню
    def menulauncher(s):
        pro = s.findqam()
        if not s.aplist == []:
            if pro:
                index = aw.popup_menu([ru(s.lgf[12]), ru(s.lgf[11])], ru(s.lgf[8] + u':'))
                if index == 0:
                    appswitch.kill_process(pro)
                    e32.ao_sleep(1e-9)
                    e32.start_exe(sys.path[0]+'\\QuickAccessMenu.exe', sys.path[0]+'\\QuickAccessMenu.py')
                elif index == 1:
                    appswitch.kill_process(pro)
            else:
                index = aw.popup_menu([ru(s.lgf[10])], ru(s.lgf[8] + u':'))
                if index == 0:
                    e32.start_exe(sys.path[0]+'\\QuickAccessMenu.exe', sys.path[0]+'\\QuickAccessMenu.py')
        elif s.aplist == [] and pro:
            index = aw.popup_menu([ru(s.lgf[11])], ru(s.lgf[8] + u':'))
            if index == 0:
                appswitch.kill_process(pro)
        else:
            aw.note(ru(s.lgf[20]), 'error')
    #переход к графической части
    #о программе
    def about(s):
        aw.app.set_tabs([],
lambda x: None)
        uitricks.set_text(ru(s.lgf[6]),3009)
        aw.app.menu=[(ru(s.lgf[6]), s.Listbox)]
        aw.app.exit_key_handler = s.Listbox
        aw.app.title=ru(s.lgf[21])
        s.img.blit(s.Img)
        s.img.text((5, 15), ru('Quick Access Menu v.0.90'), 0xffff00, u'LatinBold12')
        s.img.text((5, 27), ru('Programming:'), 0xffffff, u'LatinBold12')
        s.img.text((5, 39), ru('Alexei Muzarov'), 0xffff00, u'LatinBold12')
        s.img.text((5, 51), ru('Original idea and design:'), 0xffffff, u'LatinBold12')
        s.img.text((5, 63), ru('Alexei Muzarov'), 0xffff00, u'LatinBold12')
        s.img.text((5, 75), ru('License:'), 0xffffff, u'LatinBold12')
        s.img.text((5, 87), ru('GPL3'), 0xffff00, u'LatinBold12')
        s.img.text((5, 99), ru('e-mail:'), 0xffffff, u'LatinBold12')
        s.img.text((5, 111), ru('azexmail@gmail.com'), 0xffff00, u'LatinBold12')
        s.img.line((5, 115, 171, 115), 0xffffff)
        s.img.text((63, 128), ru('Copyright (C) 2008'), 0xffff00, u'LatinBold12')
        s.img.text((84, 141), ru('Alexei Muzarov'), 0xffff00, u'LatinBold12')
        aw.app.body=s.canv
    #выход из программы
    def exit(s):
        raise SystemExit
    #################
    #графическая часть#
    #################
    #пункт задания горячих клавиш
    def setkeys(s):
        uitricks.set_text(ru(s.lgf[6]),3009)
        aw.app.exit_key_handler = s.Listbox
        aw.app.set_tabs([],
lambda x: None)
        aw.app.title = ru(s.lgf[13])
        aw.app.menu = [(ru(s.lgf[14]), s.actset), (ru(s.lgf[6]), s.Listbox)]
        s.img.blit(s.img1)
        s.img.blit(s.img2, mask = s.img2m, target = s.coord[s.codes.index(s.hkeys[0])])
        s.img.blit(s.img2, mask = s.img2m, target = s.coord[s.codes.index(s.hkeys[1])])
        s.img.text((5, 14), (s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), 0xffff00, u'LatinBold12')
        s.img.blit(s.img3, mask = s.img3m, target = (36, 18))
        s.redraw(())
        aw.app.body = s.canv
    #включаем задание клавиш
    def actset(s):
        aw.app.menu = []
        uitricks.set_text(u'',3009)
        uitricks.set_text(u'',3000)
        aw.app.exit_key_handler = lambda: None
        s.img.blit(s.img1)
        e32.ao_sleep(0.3)
        s.swch = 1
    #отклики на нажатие клавиш
    def keycall(s, code):
        if s.swch == 1:
            scode=code[u'scancode']
            if scode in s.scode:
                if s.step == 0:
                    s.swch = 0
                    s.step = 1
                    s.hkeys[0] = s.codes[s.scode.index(scode)]
                    s.img.blit(s.img2, mask = s.img2m, target = s.coord[s.codes.index(s.hkeys[0])])
                    s.img.text((5, 14), (s.hot[s.codes.index(s.hkeys[0])] + u' + '), 0xffff00, u'LatinBold12')
                    s.redraw(())
                    e32.ao_sleep(0.5)
                    s.swch = 1
                elif s.step == 1:
                    s.swch = 0
                    s.step = 0
                    s.hkeys[1] = s.codes[s.scode.index(scode)]
                    s.img.blit(s.img2, mask = s.img2m, target = s.coord[s.codes.index(s.hkeys[1])])
                    s.img.text((5, 14), (s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])] ), 0xffff00, u'LatinBold12')
                    s.redraw(())
                    s.writeconf()
                    e32.ao_sleep(0.5)
                    s.img.blit(s.img3, mask = s.img3m, target = (36, 18))
                    s.redraw(())
                    if s.quick:
                        quick=ru(s.lgf[15])
                    else:
                        quick=ru(s.lgf[16])
                    s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], 3)
                    aw.app.menu = [(ru(s.lgf[14]), s.actset), (ru(s.lgf[6]), s.Listbox)]
                    uitricks.set_text(ru(s.lgf[6]),3009)
                    uitricks.set_text(ru(s.lgf[22]),3000)
                    aw.app.exit_key_handler = s.Listbox
        if s.swch == 2:
            kcode = code[u'keycode']
            if kcode in [63495, 63496]:
                s.swch = 0
                sensid = s.sensid
                if kcode == 63496:
                    sensid += 1
                    if sensid > 9:
                        s.swch = 2
                        return
                elif kcode == 63495:
                    sensid -= 1
                    if sensid < 0:
                        s.swch = 2
                        return
                s.sensid = sensid
                s.sens = s.senslist[s.sensid]
                s.sdraw()
                s.chng = 1
                s.swch = 2
    #обновление изображения на экране
    def redraw(s, rect):
        s.canv.blit(s.img)
    #################
    #настройка              #
    #чувствительности #
    #клавишь                 #
    #################
    def setsens(s):
        uitricks.set_text(ru(s.lgf[6]),3009)
        aw.app.exit_key_handler = s.BackToListbox
        aw.app.set_tabs([],
lambda x: None)
        aw.app.title = ru(s.lgf[24])
        aw.app.menu = [(ru(s.lgf[6]), s.Listbox)]
        s.img.clear(0x8f7fcf)
        s.img.rectangle((7, 52, 168, 93), 0x0, None, 2)
        s.img.line((9, 93, 168, 93, 168, 53), 0x99ff)
        s.sdraw()
        aw.app.body = s.canv
        s.chng = 0
        s.swch = 2
    #шкала чувствительности
    def sdraw(s):
        s.img.rectangle((9, 54, 167, 92), 0xffffff, 0xaf00af)
        s.img.text((14, 68), ru(s.lgf[25]+':'), 0xffff00, u'LatinBold12')
        if s.sensid == 9:
            coord = (144, 71)
        else:
            coord = (153, 71) 
        s.img.text(coord, ru(s.sensid + 1), 0xaaaaaa, u'Acb14')
        s.img.rectangle((12, 77, 164, 82), 0x33cc00, 0x33cc00)
        x1, y1, x2, y2 = 29, 77, 42, 82
        for stp in range(9):
            s.img.rectangle((x1, y1, x2, y2), 0x5f5fff, 0x5f5fff)
            x1 += 15
            x2 += 15
        x1, y1, x2, y2 = 14, 73, 26, 86
        for stp in range(s.sensid + 1):
            s.img.rectangle((x1, y1, x2, y2), 0x99ff, 0xff3300)
            s.img.line((x1+2, y2, x2, y2, x2, y2-12), 0x0)
            x1 += 15
            x2 += 15
        s.redraw(())
    #назад в s.Listbox()
    def BackToListbox(s):
        if s.chng:
            s.writeconf()
            if s.quick:
                quick=ru(s.lgf[15])
            else:
                quick=ru(s.lgf[16])
            s.lb4.set_list([(ru(s.lgf[3]), ru(s.menutitle), s.icon1), (ru(s.lgf[4]), ru(s.lang), s.icon2), (ru(s.lgf[5]), ru(quick), s.icon3), (ru(s.lgf[13]), ru(s.hot[s.codes.index(s.hkeys[0])] + u' + ' + s.hot[s.codes.index(s.hkeys[1])]), s.icon4), (ru(s.lgf[24]), (ru(s.lgf[25]+': ') + ru(s.sensid + 1)), s.icon5)], s.lb4.current())
        s.Listbox()

e32.ao_sleep(0.1, QAM)
lock.wait()